var ukoly;

ukoly = [];

function pridatUkol(ukol) {
  ukoly.push({
    text: ukol,
    dokoncen: false,
    priorita: 1
  });
};

function spocitejDokoncene(ukoly) {
  return ukoly.filter(function(ukol) {
    return ukol.dokoncen;
  }).length;
}

var radPodlePrioritySestupne = function(tasks) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol1.priorita - ukol2.priorita;
  });
};

var radPodlePriorityVzestupne = function(ukoly) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol2.priorita - ukol1.priorita;
  });
};

var radPodleTextu = function(ukoly) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol1.text > ukol2.text;
  });
}

var formularSeznamUkolu, elementSeznamuUkolu,
  VYSOKA_PRIORITA, STREDNI_PRIORITA, NIZKA_PRIORITA;

formularSeznamuUkolu = document.getElementById("ukoly");
elementSeznamuUkolu = formularSeznamuUkolu.getElementsByTagName("ul")[0];
VYSOKA_PRIORITA = 1;
STREDNI_PRIORITA = 2;
NIZKA_PRIORITA = 3;

function vycistiSeznam() {
  while (elementSeznamuUkolu.hasChildNodes()) {
    elementSeznamuUkolu.removeChild(elementSeznamuUkolu.lastChild);
  }
}

/**
 * Vytváří nový řádek s úkolem.
 * @param {Number} poradi Indexové pořadí nového řádku.
 * @param {Object} ukol Objekt úkolu.
 * @returns {Node} Uzel nového řádku.
 */
function vytvorNovyRadek(poradi, ukol) {
  var sablona, novyRadek, textovyElement;

  sablona = document.getElementsByClassName("sablona-polozky")[0];
  novyRadek = sablona.cloneNode(true);
  novyRadek.setAttribute("data-poradi", poradi.toString());

  // hledáme element pro text úkolu
  textovyElement = novyRadek.getElementsByClassName("text-ukolu")[0];

  // nastavujeme prioritu úkolu
  if (ukol.priorita == VYSOKA_PRIORITA) {
    textovyElement.className += " label-danger";
  } else if (ukol.priorita == NIZKA_PRIORITA) {
    textovyElement.className += " label-success";
  }

  // nastavujeme text úkolu
  textovyElement.appendChild(document.createTextNode(ukol.text));

  // označujeme dokončený úkol
  if (ukol.dokoncen) {
    novyRadek.getElementsByTagName("input")[0]
      .setAttribute("checked", "checked");
    textovyElement.className += " dokoncen";
  }

  novyRadek.className = "ukol";

  return novyRadek;
}

/**
 * Zobrazuje seznam úkolů podle aktuálního obsahu pole ukoly.
 */
function zobrazSeznamUkolu() {
  var i, ukol, elementUkolu;

  vycistiSeznam();

  for (i = 0; i < ukoly.length; i++) {
    ukol = ukoly[i];
    elementUkolu = vytvorNovyRadek(i, ukol);
    elementSeznamuUkolu.appendChild(elementUkolu);
  }
}