var ukoly, formularSeznamUkolu, elementSeznamuUkolu,
  VYSOKA_PRIORITA, STREDNI_PRIORITA, NIZKA_PRIORITA,
  formularPridat, poleNovehoUkolu, elementVarovani,
  odkazRadPodlePriorityVzestupne, odkazRadPodlePrioritySestupne,
  odkazRadPodleTextu;

ukoly = [];
formularSeznamuUkolu = document.getElementById("ukoly");
elementSeznamuUkolu = formularSeznamuUkolu.getElementsByTagName("ul")[0];
formularPridat = document.getElementById("pridat");
poleNovehoUkolu = document.getElementById("novyUkol");
elementVarovani = document.getElementById("varovani");
odkazRadPodlePriorityVzestupne =
  document.getElementById("radPodlePriorityVzestupne");
odkazRadPodlePrioritySestupne =
  document.getElementById("radPodlePrioritySestupne");
odkazRadPodleTextu =
  document.getElementById("radPodleTextu");
VYSOKA_PRIORITA = 1;
STREDNI_PRIORITA = 2;
NIZKA_PRIORITA = 3;

function pridatUkol(ukol) {
  ukoly.push({
    text: ukol,
    dokoncen: false,
    priorita: STREDNI_PRIORITA
  });
  zobrazSeznamUkolu();
  return ukol;
};

function spocitejDokoncene(ukoly) {
  return ukoly.filter(function(ukol) {
    return ukol.dokoncen;
  }).length;
}

var radPodlePrioritySestupne = function(tasks) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol1.priorita - ukol2.priorita;
  });
};

var radPodlePriorityVzestupne = function(ukoly) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol2.priorita - ukol1.priorita;
  });
};

var radPodleTextu = function(ukoly) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol1.text > ukol2.text;
  });
}

odkazRadPodlePriorityVzestupne.onclick = function(e) {
  preventDefault(e);
  ukoly = radPodlePriorityVzestupne(ukoly);
  zobrazSeznamUkolu();
};

odkazRadPodlePrioritySestupne.onclick = function(e) {
  preventDefault(e);
  ukoly = radPodlePrioritySestupne(ukoly);
  zobrazSeznamUkolu();
}

odkazRadPodleTextu.onclick = function(e) {
  preventDefault(e);
  ukoly = radPodleTextu(ukoly);
  zobrazSeznamUkolu();
};

function vycistiSeznam() {
  while (elementSeznamuUkolu.hasChildNodes()) {
    elementSeznamuUkolu.removeChild(elementSeznamuUkolu.lastChild);
  }
}

/**
 * Vytváří nový řádek s úkolem.
 * @param {Number} poradi Indexové pořadí nového řádku.
 * @param {Object} ukol Objekt úkolu.
 * @returns {Node} Uzel nového řádku.
 */
function vytvorNovyRadek(poradi, ukol) {
  var sablona, novyRadek, textovyElement;

  sablona = document.getElementsByClassName("sablona-polozky")[0];
  novyRadek = sablona.cloneNode(true);
  novyRadek.setAttribute("data-poradi", poradi.toString());

  // hledáme element pro text úkolu
  textovyElement = novyRadek.getElementsByClassName("text-ukolu")[0];

  // nastavujeme prioritu úkolu
  if (ukol.priorita == VYSOKA_PRIORITA) {
    textovyElement.className += " label-danger";
  } else if (ukol.priorita == NIZKA_PRIORITA) {
    textovyElement.className += " label-success";
  }

  // nastavujeme text úkolu
  textovyElement.appendChild(document.createTextNode(ukol.text));

  // označujeme dokončený úkol
  if (ukol.dokoncen) {
    novyRadek.getElementsByTagName("input")[0]
      .setAttribute("checked", "checked");
    textovyElement.className += " dokoncen";
  }

  novyRadek.className = "ukol";

  return novyRadek;
}

/**
 * Zobrazuje seznam úkolů podle aktuálního obsahu pole ukoly.
 */
function zobrazSeznamUkolu() {
  var i, ukol, elementUkolu;

  vycistiSeznam();

  for (i = 0; i < ukoly.length; i++) {
    ukol = ukoly[i];
    elementUkolu = vytvorNovyRadek(i, ukol);
    elementSeznamuUkolu.appendChild(elementUkolu);
  }
}

function varuj(zprava) {
  elementVarovani.innerHTML = zprava;
}

function vyprazdniVarovani() {
  elementVarovani.innerHTML = "";
}

function preventDefault(e) {
  e = e || window.event;
  if (e.preventDefault) {
    e.preventDefault();
  } else {
    e.returnValue = false;
  }
}

formularPridat.onsubmit = function(e) {
  var zadani;
  preventDefault(e);
  zadani = poleNovehoUkolu.value;
  if (zadani === "") {
    varuj("Prosím zadejte úkol.");
  } else {
    poleNovehoUkolu.value = "";
    vyprazdniVarovani();
    pridatUkol(zadani);
  }
};

function urciCil(e) {
  return e.srcElement || e.target;
}

function urciPoradi(el) {
  while (!el.getAttribute("data-poradi")) {
    el = el.parentNode;
  }
  return el.getAttribute("data-poradi");
}

function nastavPrioritu(poradi, hodnota) {
  ukoly[poradi].priorita = hodnota;
  zobrazSeznamUkolu();
};

function smazUkol(poradi) {
  ukoly.splice(poradi, 1);
  zobrazSeznamUkolu();
};

function prepniPriznakDokonceni(poradi) {
  var hodnota = ukoly[poradi].dokoncen;
  ukoly[poradi].dokoncen = !hodnota;
  zobrazSeznamUkolu();
};

formularSeznamuUkolu.onclick = function(e) {
  var cil, poradi, tridaCile;
  preventDefault(e);
  cil = urciCil(e);
  poradi = urciPoradi(cil);
  if (poradi) {
    poradi = Number(poradi);
    tridaCile = cil.getAttribute('class');
    if (tridaCile === 'vysoka-priorita' ||
        tridaCile === 'stredni-priorita' ||
        tridaCile === 'nizka-priorita') {
      nastavPrioritu(poradi, cil.getAttribute("value"));
    } else if (tridaCile && tridaCile.match("smazat-ukol")) {
      smazUkol(poradi);
    } else if (cil.type === "checkbox") {
      prepniPriznakDokonceni(poradi);
    }
  }
};