var ukoly, formularSeznamUkolu, elementSeznamuUkolu,
  VYSOKA_PRIORITA, STREDNI_PRIORITA, NIZKA_PRIORITA,
  formularPridat, poleNovehoUkolu, elementVarovani,
  odkazRadPodlePriorityVzestupne, odkazRadPodlePrioritySestupne,
  odkazRadPodleTextu;

ukoly = [];
formularSeznamuUkolu = document.getElementById("ukoly");
elementSeznamuUkolu = formularSeznamuUkolu.getElementsByTagName("ul")[0];
formularPridat = document.getElementById("pridat");
poleNovehoUkolu = document.getElementById("novyUkol");
elementVarovani = document.getElementById("varovani");
odkazRadPodlePriorityVzestupne =
  document.getElementById("radPodlePriorityVzestupne");
odkazRadPodlePrioritySestupne =
  document.getElementById("radPodlePrioritySestupne");
odkazRadPodleTextu =
  document.getElementById("radPodleTextu");
VYSOKA_PRIORITA = 1;
STREDNI_PRIORITA = 2;
NIZKA_PRIORITA = 3;

function pridatUkol(ukol) {
  ukoly.push({
    text: ukol,
    dokoncen: false,
    priorita: STREDNI_PRIORITA
  });
  zobrazSeznamUkolu();
  return ukol;
};

function spocitejDokoncene(ukoly) {
  return ukoly.filter(function(ukol) {
    return ukol.dokoncen;
  }).length;
}

var radPodlePrioritySestupne = function(tasks) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol1.priorita - ukol2.priorita;
  });
};

var radPodlePriorityVzestupne = function(ukoly) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol2.priorita - ukol1.priorita;
  });
};

var radPodleTextu = function(ukoly) {
  return ukoly.sort(function(ukol1, ukol2) {
    return ukol1.text > ukol2.text;
  });
}

odkazRadPodlePriorityVzestupne.onclick = function(e) {
  preventDefault(e);
  ukoly = radPodlePriorityVzestupne(ukoly);
  zobrazSeznamUkolu();
};

odkazRadPodlePrioritySestupne.onclick = function(e) {
  preventDefault(e);
  ukoly = radPodlePrioritySestupne(ukoly);
  zobrazSeznamUkolu();
}

odkazRadPodleTextu.onclick = function(e) {
  preventDefault(e);
  ukoly = radPodleTextu(ukoly);
  zobrazSeznamUkolu();
};

function vycistiSeznam() {
  while (elementSeznamuUkolu.hasChildNodes()) {
    elementSeznamuUkolu.removeChild(elementSeznamuUkolu.lastChild);
  }
}

/**
 * Vytváří nový řádek s úkolem.
 * @param {Number} poradi Indexové pořadí nového řádku.
 * @param {Object} ukol Objekt úkolu.
 * @returns {Node} Uzel nového řádku.
 */
function vytvorNovyRadek(poradi, ukol) {
  var sablona, novyRadek, textovyElement;

  sablona = document.getElementsByClassName("sablona-polozky")[0];
  novyRadek = sablona.cloneNode(true);
  novyRadek.setAttribute("data-poradi", poradi.toString());

  // hledáme element pro text úkolu
  textovyElement = novyRadek.getElementsByClassName("text-ukolu")[0];

  // nastavujeme prioritu úkolu
  if (ukol.priorita == VYSOKA_PRIORITA) {
    textovyElement.className += " label-danger";
  } else if (ukol.priorita == NIZKA_PRIORITA) {
    textovyElement.className += " label-success";
  }

  // nastavujeme text úkolu
  textovyElement.appendChild(document.createTextNode(ukol.text));

  // označujeme dokončený úkol
  if (ukol.dokoncen) {
    novyRadek.getElementsByTagName("input")[0]
      .setAttribute("checked", "checked");
    textovyElement.className += " dokoncen";
  }

  novyRadek.className = "ukol";

  return novyRadek;
}

/**
 * Zobrazuje seznam úkolů podle aktuálního obsahu pole ukoly.
 */
function zobrazSeznamUkolu() {
  var i, ukol, elementUkolu;

  vycistiSeznam();

  for (i = 0; i < ukoly.length; i++) {
    ukol = ukoly[i];
    elementUkolu = vytvorNovyRadek(i, ukol);
    elementSeznamuUkolu.appendChild(elementUkolu);
  }

  ulozUkoly(ukoly);
  zobrazGraf(ukoly);
}

if (existujeLokalniUloziste() && localStorage.ukoly)  {
  ukoly = JSON.parse(localStorage.ukoly);
  zobrazSeznamUkolu();
}

function varuj(zprava) {
  elementVarovani.innerHTML = zprava;
}

function vyprazdniVarovani() {
  elementVarovani.innerHTML = "";
}

function preventDefault(e) {
  e = e || window.event;
  if (e.preventDefault) {
    e.preventDefault();
  } else {
    e.returnValue = false;
  }
}

formularPridat.onsubmit = function(e) {
  var zadani;
  preventDefault(e);
  zadani = poleNovehoUkolu.value;
  if (zadani === "") {
    varuj("Prosím zadejte úkol.");
  } else {
    poleNovehoUkolu.value = "";
    vyprazdniVarovani();
    pridatUkol(zadani);
  }
};

function urciCil(e) {
  return e.srcElement || e.target;
}

function ulozUkoly(ukoly) {
  if (existujeLokalniUloziste()) {
    localStorage.ukoly = JSON.stringify(ukoly);
  }
}

function urciPoradi(el) {
  while (!el.getAttribute("data-poradi")) {
    el = el.parentNode;
  }
  return el.getAttribute("data-poradi");
}

function nastavPrioritu(poradi, hodnota) {
  ukoly[poradi].priorita = hodnota;
  zobrazSeznamUkolu();
};

function smazUkol(poradi) {
  ukoly.splice(poradi, 1);
  zobrazSeznamUkolu();
};

function prepniPriznakDokonceni(poradi) {
  var hodnota = ukoly[poradi].dokoncen;
  ukoly[poradi].dokoncen = !hodnota;
  zobrazSeznamUkolu();
};

formularSeznamuUkolu.onclick = function(e) {
  var cil, poradi, tridaCile;
  preventDefault(e);
  cil = urciCil(e);
  poradi = urciPoradi(cil);
  if (poradi) {
    poradi = Number(poradi);
    tridaCile = cil.getAttribute('class');
    if (tridaCile === 'vysoka-priorita' ||
        tridaCile === 'stredni-priorita' ||
        tridaCile === 'nizka-priorita') {
      nastavPrioritu(poradi, cil.getAttribute("value"));
    } else if (tridaCile && tridaCile.match("smazat-ukol")) {
      smazUkol(poradi);
    } else if (cil.type === "checkbox") {
      prepniPriznakDokonceni(poradi);
    }
  }
};

function existujeLokalniUloziste() {
  return typeof(Storage) !== "undefined";
}


function spocitejDokoncene(ukoly) {
  return ukoly.filter(function(ukol) {return ukol.dokoncen}).length;
}

function zobrazGraf(ukoly) {
  var dokoncenych = spocitejDokoncene(ukoly);
  var nesplnenych = ukoly.length - dokoncenych;

  document.getElementById("nesplneno").innerHTML = nesplnenych;
  document.getElementById("dokonceno").innerHTML = dokoncenych;

  var hodnoty = [nesplnenych, dokoncenych];
  var maximalniHodnota = nesplnenych > dokoncenych ? nesplnenych : dokoncenych;

  var horniOkraj = 25;
  var spodniOkraj = 1;
  var platno = document.getElementById("platno");

  platno.width = platno.width;

  if (platno && platno.getContext) {
    var kontext = platno.getContext("2d");
    kontext.fillStyle = '#FFFFFF';
    kontext.fillRect(0, 0, platno.width, platno.height);
    kontext.strokeStyle = '#000000';
    kontext.strokeRect(0, 0, platno.width, platno.height);

    var textX = 10;
    var textY = 190;

    kontext.fillStyle = '#000000';
    kontext.save();
    kontext.translate(textX, textY);
    kontext.rotate(Math.PI * -90 / 180);
    kontext.fillText('Počet úkolů', 0, 0);
    kontext.restore();

    var meritkoOsyY = (platno.height - horniOkraj) / (maximalniHodnota);
    var pocet =  0;

    for (var hodnotaOsyY = maximalniHodnota; hodnotaOsyY >= 0;
        hodnotaOsyY -= 1) {
      var souradniceY = horniOkraj - spodniOkraj + (meritkoOsyY * pocet);
      kontext.fillText(hodnotaOsyY, 40, souradniceY);
      pocet++;

      kontext.moveTo(0, souradniceY);
      kontext.lineTo(platno.width, souradniceY);
    }

    kontext.lineWidth = 0.1;
    kontext.stroke();

    var meritkoOsyX = platno.width / (hodnoty.length + 1);

    function nakresliObdelniky(kontext) {
      for (var i = 0; i < hodnoty.length; i++) {
        var pocatekX = i + 1;
        var pocatekY = spodniOkraj/meritkoOsyX;
        var konecX = 2;
        var konecY = hodnoty[i];
        var sirka = 0.5;
        var prechod = kontext.createLinearGradient(pocatekX, pocatekY,
          konecX, konecY);

        prechod.addColorStop(0.0, "#8ED6FF");
        prechod.addColorStop(1.0, "#004CB3");

        kontext.fillStyle = prechod;
        kontext.fillRect(pocatekX, pocatekY, sirka, konecY);
      }
    }

    var popisky = ["Nesplněno", "Dokončeno"];
    kontext.textBaseline = "bottom";

    for (var i = 0; i < hodnoty.length; i++) {
      var souradniceY = platno.height - hodnoty[i] * meritkoOsyY;
      kontext.fillText(popisky[i], meritkoOsyX * (i + 1), souradniceY);
    }

    kontext.translate(0, platno.height);
    kontext.scale(meritkoOsyX, -1 * meritkoOsyY);
    kontext.shadowOffsetX = 2;
    kontext.shadowOffsetY = 2;
    kontext.shadowBlur = 2;
    kontext.shadowColor = "rgba(0, 0, 0, 0.5)";
    nakresliObdelniky(kontext);

    document.getElementById('tiskGrafu').href = platno.toDataURL();
  }
}

zobrazGraf(ukoly);